"use strict";

var responseTypes = require("./responseTypes");

var genericFunction = require("../utils/genericFunction");

var sorryMessages = ["Sorry, my team is working on a technical issue. Please try after sometime.", "Ohh... there is an issue that the team is working currently on. Could you please try later", "I'm sorry, there is some technical issue that the team is working on. Please try after sometime."];

function getBotResponseTemplate() {
  return {
    userId: "",
    conversationId: "",
    transactionId: "",
    sender: "Bot",
    timestamp: "",
    messageType: "",
    message: "",
    followMessage: []
  };
}

function generateBotResponse(obj) {
  console.log("generateBotResponse >", obj);

  if (!obj.botResponse) {
    obj.botResponse = {
      messageType: responseTypes.plainText,
      message: sorryMessages[genericFunction.generateRandomNo(0, sorryMessages.length - 1)]
    };
  }

  var botResponse = getBotResponseTemplate();
  var date = new Date();
  botResponse.userId = obj.userId ? obj.userId : "000";
  botResponse.conversationId = obj.convId ? obj.convId : "convid000";
  botResponse.transactionId = obj.transId ? obj.transId : "transid000";
  botResponse.timestamp = genericFunction.formatDate(date);
  botResponse.messageType = obj.botResponse.messageType ? obj.botResponse.messageType : responseTypes.plainText;
  botResponse.message = obj.botResponse.message ? obj.botResponse.message : "";
  botResponse.followMessage = obj.botResponse.followMessage ? obj.botResponse.followMessage : [];
  console.log(botResponse);
  return botResponse;
}

module.exports = generateBotResponse;